#ifndef GATEWAYCLIENT_H
#define GATEWAYCLIENT_H

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <syslog.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/time.h>

//Bluetooth Part Headers
#include <bluetooth/bluetooth.h>
#include <bluetooth/hci.h>
#include <bluetooth/hci_lib.h>
#include <bluetooth/rfcomm.h>
#include <bluetooth/sdp.h>
#include <bluetooth/sdp_lib.h>

//RSA security
#include <openssl/rsa.h>
#include <openssl/pem.h>


//List Treatment
#include "listsc.h"
#include "bnepc.h"

//time probes
#include <time.h>

#define VERSION "1.0"
#define MAXDATASIZE 100
#define PUB_KEY "pub.key"
#define KEY_FILE "key.file"

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif
    
  
    
    typedef struct{
	char interface[20];
	int bluetooth_id;
	int blue_sock;
	int wi_sock;
    } ifaces_t;
    
    typedef struct{
	char addr[20];
	char name[20];
	char type[20];
    } local_descr_t;
    
    typedef struct{
	struct sockaddr_in ip_address;
	struct sockaddr_in ip_gate; 
	struct sockaddr_in ip_mask; 
    }conf_params;
    
   typedef struct {
        char message[256];
   }datasend;
    
    
    int  RSA_security(int sk);
    void cmd_name(int hdev, char *dev_name);
    void cmd_class(int hdev,  char *dev_class);
    int localdescr(local_descr_t *servd,ifaces_t *iface);
    void enable_scan(int ctl, int hdev);
    int manet_search(List *list, int len);
    int do_connect(char *baddr,conf_params *params);



#ifdef __cplusplus
}
#endif


#endif
