/*
*  C Implementation: Gateway_Client
*
* Copyright (C) -2007  MªCruz Olivas Delgado <maoldel@teleco.upv.es>
*
* 	This file is part of MANET_Gateway.

    MANET_Gateway is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MANET_Gateway is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MANET_Gateway; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
* 
*
*/

#include "listsc.h"

int auto_insert(List *list, char *name, char *string_address){
    
    Nodetype  *previous, *newnode;
    int aux;

    /* Create a new node */
    newnode = (Nodetype *)malloc(sizeof(Nodetype));
    
    if(EmptyList(*list)) {
	newnode->next = *list; 
	newnode->id=1;
	newnode->name = name;
	newnode->string_addr = string_address;
	*list = newnode;
    }
    else {
	previous = *list;
	while(previous->next) 
		previous = previous->next;
	aux =(previous->id);
	newnode->id=aux+1; 
	newnode->name = name;
	newnode->string_addr = string_address;
	newnode->next = previous->next;
	previous->next = newnode;
    }

    return newnode->id;
}


int EmptyList(List list){
    
    return (list == NULL);
}


Nodetype *ListNode(List list, int id){
    
    Nodetype *node;
    node = list;

    while(node) {
	if((node->id)== id) return node;
	node = node->next;
    }
    return NULL;
}



