 
#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <qmainwindow.h>
#include <qapplication.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qtextedit.h>
#include <qpushbutton.h>
#include <qevent.h>
#include <qspinbox.h>
#include <qmessagebox.h>
#include <qlistbox.h>
#include <qstatusbar.h>
#include <qprogressbar.h>
#include <qbuttongroup.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qinputdialog.h>
#include <qaction.h>


#include "myspinbox.h"
#include "gatewayclient.h"
#include "thread.h"



class QLabel;
class QPixmap;
class QFrame;
class QPushButton;
class QTextEdit;
class QHBoxLayout;
class QVBoxLayout;
class QSpinBox;
class QButtonGroup;
class QInputDialog;
class QAction;
class Thread;


class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    MainWindow(QWidget *parent = 0, const char *name = 0);
    void closeEvent( QCloseEvent* ce );
    void customEvent(QCustomEvent *event);

    
private:
    int init();
    int descr_local_device();
    void createMenuBar();

private slots:
   void do_inquiry();
   void gate_connect();
   void gate_disconnect();
   void enter_key();
   void about();
   
private:
    List list;
    int begin;
    ifaces_t iface;
    conf_params params;
    Thread disconThread;
    
    QLabel *grclogoLabel;
    QLabel *tasksLabel;
    QLabel *serversLabel;
    QLabel *scantimeLabel;
    QLabel *bluetoothlogoLabel;
    QLabel *addressvalue;
    QLabel *namevalue;
    QLabel *typevalue;

    QPushButton *searchButton;
    QPushButton *connectButton;
    QPushButton *disconnectButton;
    QPushButton *exitButton;
    QPushButton *keyButton;

    QSpinBox *scantimeSpinBox;

    QListBox *tasksText;
    QListBox *serversText;

    QButtonGroup *localdeviceButtonGroup;

    QHBoxLayout *topLayout;
    QVBoxLayout *topLayoutmedium;
    
    
    QHBoxLayout *mediumLayout;
    QVBoxLayout *mediumLayoutleft;
    QVBoxLayout *mediumLayoutmedium;
    QVBoxLayout *mediumLayoutright;
    
    QHBoxLayout *bottomLayout;
    QVBoxLayout *bottomLayoutright;
    QHBoxLayout *bottomLayoutkey;
    QVBoxLayout *mainLayout;
    

    QPopupMenu *helpMenu;
    QMenuBar *menuBar;
    
    QAction *aboutAct;
    QAction *aboutQtAct;
    
};

#endif
