  
/*
*  C Implementation: Gateway_Server
*
* Copyright (C) -2007  MªCruz Olivas Delgado <maoldel@teleco.upv.es>
*
* 	This file is part of MANET_Gateway.

    MANET_Gateway is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MANET_Gateway is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MANET_Gateway; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
* 
*
*/

#include "gatewayserver.h"


static bdaddr_t src_addr = *BDADDR_ANY;
static uint16_t role = BNEP_SVC_NAP;  /*local role*/
static char netdev[16] = "bnep%d";
volatile int soc_l2cap;
static sdp_record_t *record;

conf_params params;



//RSA routines

int RSA_write_files(){      //returns 0 if success, 1 if error
    
        RSA *key;
        FILE *pub_keyfile,*priv_keyfile = NULL;
    
        key = RSA_generate_key(2048, 65537, NULL, NULL);
     
        if((pub_keyfile = fopen(PUB_KEY, "wb")) == NULL){
                fprintf(stderr, "fopen()\n");
               return 1;
        }

        PEM_write_RSAPublicKey(pub_keyfile, key);
        fclose(pub_keyfile);

        if((priv_keyfile = fopen(PRIV_KEY, "wb")) == NULL){ 
                fprintf(stderr, "fopen()\n");
                return 1;
        }

        PEM_write_RSAPrivateKey(priv_keyfile, key, NULL, NULL, 0, NULL, NULL);
        fclose(priv_keyfile);

       return 0;
} 

int RSA_security(int nsk){
    
      char buf[2048] = { 0 };
      char aux[256];
      int f,numbytes,bytes_rfile;
      char file_buf[2048] = { 0 };
      unsigned char array[256] = {0};
      RSA *key;
      datarec data;
      FILE *file,*priv_keyfile = NULL;
      memset(buf, 0, sizeof(buf));
      
      //send the file with public key
			
       f=open(PUB_KEY,O_RDONLY);
       
       bytes_rfile = read(f,file_buf,sizeof(file_buf));
       

       if(write(nsk,file_buf,bytes_rfile)<0) {
	printf("File send error rsa\n");
                return 1;
       }
       
       close(f);
	//receive the encoded message
       if ((numbytes = recv(nsk, array, 256 , 0)) == -1) {
	perror("recv");
	return 1;
      }
	//decode the message
       if((priv_keyfile = fopen(PRIV_KEY, "r")) == NULL){
                fprintf(stderr, "fopen()\n");
                return 1;
        }
       
       key=PEM_read_RSAPrivateKey(priv_keyfile, NULL, NULL, NULL);
      memset(&data, 0, sizeof(datarec));
       RSA_private_decrypt(256, array, (unsigned char *)&data , key, RSA_PKCS1_PADDING);
       array[numbytes] = '\0';
    
       //make a comparison
       file=fopen(KEY_FILE,"r");
       fscanf(file," %s\n",aux);
       fclose(file);
       if(strncmp(data.message,aux,256)==0) return 0;
       else return 1;
    
}


int check_MAC(char *str){

	FILE *arch;
	char aux[255];
	
	if((arch=fopen(MAC_FILE,"r"))==NULL){
		printf("no se puede abrir el archivo de MACs\n");
		return 1;
	}
	while(!feof(arch)){
	    fscanf(arch," %s\n",aux);
	    if(strncmp(aux,str,40)==0){ 
		fclose(arch);
		return 0;
	    }
	}
	fclose(arch);
	return 2;
}



//Bluetooth routines

int get_max_clients(){
     return params.max_hosts;    
}

void cmd_name(int hdev, char *dev_name){
    int s = hci_open_dev(hdev);
    char name[248];
    
    if (s < 0) {
	printf("Can't open device hci%d. \n", hdev);
	exit(1);
    }
    
   if (hci_read_local_name(s, sizeof(name), name, 1000) < 0) {
	printf("Can't read local name on hci%d. \n", hdev);
	exit(1);
    }
    strcpy(dev_name, (char *)name);
    
}


void cmd_class(int hdev,  char *dev_class){
    static char *major_devices[] = { "Miscellaneous",
				     "Computer",
				     "Phone",
				     "LAN Access",
				     "Audio/Video",
				     "Peripheral",
				     "Imaging",
				     "Uncategorized" };
    int s = hci_open_dev(hdev);
    
    if (s < 0) {
	printf("Can't open device hci%d. \n", hdev);
	exit(1);
    }
    uint8_t cls[3];
    if (0 > hci_read_class_of_dev(s, cls, 1000)) {
	printf("Can't read class of device on hci%d. \n", hdev);
	exit(1);
    }
    if ((cls[1] & 0x1f) > sizeof(major_devices))
	printf("Invalid Device Class!\n");
    else{
	strcpy(dev_class, (char *)major_devices[cls[1] & 0x1f]);
	
    }
    
}



int localdescr(local_descr_t *servd,ifaces_t *iface){
    int ctl;
    int hdev;
    static struct hci_dev_info di;
  
    
    /* Open HCI socket  */
    if ((ctl = socket(AF_BLUETOOTH, SOCK_RAW, BTPROTO_HCI)) < 0) {
	perror("Can't open HCI socket.\n");
	return -1;
    }
    if((hdev = hci_get_route(NULL))<0){
	perror("Can't get route to device\n");
	close(ctl);
	return -1;
    }
    
    
    ioctl(ctl, HCIGETDEVINFO,(void *)&di);
    
    ba2str(&di.bdaddr, (char *)&servd->addr); 
    
    
    cmd_class(hdev, (char *)&servd->type);
    
    
    if((hdev = hci_get_route(NULL))<0){
	perror("Can't get route to device\n");
	close(ctl);
	return -1;
    }
   cmd_name(hdev, (char *)&servd->name);  
    
    iface->bluetooth_id=hdev;
    iface->blue_sock=ctl;

     // start the bnep module
    if(bnep_init()<0)
        return -1;
    
    return 0; 
    
}
    


int add_service(void){

	uint32_t service_uuid_int[] = { 0, 0, 0, 0x1BFF };

	const char *service_name = "MANET_Gateway";
	const char *service_dsc = "A Gateway for Bluetooth Devices in Ad Hoc Network";
	const char *service_prov = "GRC";
	
	uuid_t root_uuid, l2cap_uuid, bnep_uuid, pan_uuid,svc_uuid;
	sdp_list_t *l2cap_list = 0, *root_list = 0, *proto_list[2] , *svclass_list=0, *access_proto_list = 0, *apseq_list=0; sdp_list_t *pfseq_list=0;
	uint16_t psm = 15, version = 0x0100;
	sdp_profile_desc_t profile[1];

	//sdp_record_t *record = sdp_record_alloc();
	record = sdp_record_alloc();

	// set the general service ID
	sdp_uuid128_create( &svc_uuid, &service_uuid_int );
	sdp_set_service_id( record, svc_uuid );

	// make the service record publicly browsable
	sdp_uuid16_create(&root_uuid, PUBLIC_BROWSE_GROUP);
	root_list = sdp_list_append(0, &root_uuid);
	sdp_set_browse_groups( record, root_list );

	// set l2cap information
	sdp_uuid16_create(&l2cap_uuid, L2CAP_UUID);
	proto_list[0] = sdp_list_append(NULL, &l2cap_uuid);
	proto_list[0] = sdp_list_append(proto_list[0], sdp_data_alloc(SDP_UINT16, &psm));
	apseq_list    = sdp_list_append(NULL, proto_list[0]);

	//set bnep information
	sdp_uuid16_create(&bnep_uuid, BNEP_UUID);
	proto_list[1] = sdp_list_append(NULL, &bnep_uuid);
	proto_list[1] = sdp_list_append(proto_list[1], sdp_data_alloc(SDP_UINT16, &version));

	
 	/* Supported protocols */
	{
		uint16_t ptype[4] = { 
			0x0800,  /* IPv4 */
			0x0806,  /* ARP */
		};
		sdp_data_t *head, *pseq;
		int p;

		for (p = 0, head = NULL; p < 2; p++) {
			sdp_data_t *data = sdp_data_alloc(SDP_UINT16, &ptype[p]);
			        if (head)
					sdp_seq_append(head, data);
                        	else
                                	head = data;
                }
                pseq = sdp_data_alloc(SDP_SEQ16, head);
                proto_list[1] = sdp_list_append(proto_list[1], pseq);
	}

	// attach protocol information to service record
	apseq_list   = sdp_list_append(apseq_list, proto_list[1]);
	access_proto_list = sdp_list_append( 0, apseq_list);
	sdp_set_access_protos( record, access_proto_list );

	//set the information of the NAP
	sdp_uuid16_create(&pan_uuid, NAP_SVCLASS_ID);
	svclass_list = sdp_list_append(NULL, &pan_uuid);
	sdp_set_service_classes(record, svclass_list);
	sdp_uuid16_create(&profile[0].uuid, NAP_PROFILE_ID);
	profile[0].version = 0x0100;
	pfseq_list = sdp_list_append(NULL, &profile[0]);
	sdp_set_profile_descs(record, pfseq_list);

	// set the name, provider, and description
	sdp_set_info_attr(record, service_name, service_prov, service_dsc);
	int err = 0;
	sdp_session_t *session = 0;

	// connect to the local SDP server, register the service record, and 
	// disconnect
	session = sdp_connect( BDADDR_ANY, BDADDR_LOCAL, SDP_RETRY_IF_BUSY );
	if (!session) {
		printf( "Failed to connect to the local SDP server");
        	return -1;
	}
	err = sdp_record_register(session, record, SDP_RECORD_PERSIST);
	if (err < 0) {
		printf("Service Record registration failed\n");
		sdp_record_free(record); record = NULL;
		sdp_close(session);
	}
	else{
		printf("Service registration completed\n");
		printf("0x%x\n",record->handle);
	}

	// cleanup
	sdp_list_free( l2cap_list, 0 );
	sdp_list_free( root_list, 0 );
	sdp_list_free( access_proto_list, 0 );
	sdp_list_free( proto_list[0], 0 );
	sdp_list_free( proto_list[1], 0 );
	sdp_list_free( svclass_list, 0 );
	sdp_list_free( pfseq_list, 0 );

	return err;
}

int del_manet_service() // Eliminates the last MANET Gateway handle
{
	
	sdp_session_t *sess;
	
	sess = sdp_connect(BDADDR_ANY, BDADDR_LOCAL, SDP_RETRY_IF_BUSY);
	if (!sess) {
		printf("No local SDP server!\n");
	}
	
	if (!record) {
		printf("Service Record not found.\n");
        	sdp_close(sess);
        	return -1;
	}
	if (sdp_record_unregister(sess, record)) {
		printf("Failed to unregister service record\n");
		sdp_close(sess);
		return -1;
	}
	printf("Service Record deleted.\n");
	sdp_close(sess);
	return 0;
}


int do_listen()
{
                char cad[255];
	char cad2[255];
	
	struct l2cap_options l2o;
	struct sockaddr_l2 l2a;
	socklen_t olen;
	int  lm;
	char *ip_dest=NULL;
	char str[40];
	int num_clients;
	
	//obtaining the ip_dest
	ip_dest=inet_ntoa(dest.sin_addr);
	
	/* Create L2CAP socket and bind it to PSM BNEP */
	soc_l2cap = socket(AF_BLUETOOTH, SOCK_SEQPACKET, BTPROTO_L2CAP);
	if (soc_l2cap < 0) {
		printf( "Cannot create L2CAP socket\n");
		return -1;
	}

	memset(&l2a, 0, sizeof(l2a));
	l2a.l2_family = AF_BLUETOOTH;
	bacpy(&l2a.l2_bdaddr, &src_addr);
	l2a.l2_psm = htobs(BNEP_PSM);
	
	
	if (bind(soc_l2cap, (struct sockaddr *) &l2a, sizeof(l2a))) {
		printf("Bind failed\n");
		return -1;
	}

	/* Setup L2CAP options according to BNEP spec */
	memset(&l2o, 0, sizeof(l2o));
	olen = sizeof(l2o);
	if (getsockopt(soc_l2cap, SOL_L2CAP, L2CAP_OPTIONS, &l2o, &olen) < 0) {
		printf("Failed to get L2CAP options\n");
		return -1;
	}

	l2o.imtu = l2o.omtu = BNEP_MTU;
	if (setsockopt(soc_l2cap, SOL_L2CAP, L2CAP_OPTIONS, &l2o, sizeof(l2o)) < 0) {
		printf("Failed to set L2CAP options \n");
		return -1;
	}

	/* Set link mode */
	lm = 0;
	lm |= L2CAP_LM_MASTER;
	
	if (lm && setsockopt(soc_l2cap, SOL_L2CAP, L2CAP_LM, &lm, sizeof(lm)) < 0) {
		printf("Failed to set link mode \n");
		return -1;
	}

	listen(soc_l2cap,params.max_hosts);
	while (1) {
		socklen_t alen = sizeof(l2a);
		int nsk;
	
		nsk = accept(soc_l2cap, (struct sockaddr *) &l2a, &alen);
		if (nsk < 0) {
			printf("Accept failed. \n");
			continue;
		}

		switch (fork()) {
		case 0:
		                break;
		case -1:
			printf("Fork failed \n");
		default:
		                ip_dest=suma_ip(1);
			close(nsk);
			continue;
		}
		
		ba2str(&l2a.l2_bdaddr, str);
				
		num_clients=bnep_count_connections();
		if(num_clients==params.max_hosts){
		    printf("server can't serve more clients\n");
		    exit(0);		
		}
	
		//check level security
	
		if((params.seculevel==1) || (params.seculevel==3)){ //check  MACs
		    printf("chequeo las macs");
		    printf("string clietne %s",str);
		    int i=check_MAC(str);
		    printf("valor retornado por chec macs %i\n",i);
		    if((i==0) || (i==1) )printf("acepto la conexión \n");
		    else{
			printf("no acepto la conexión \n");
			 close(nsk);
			exit(0);
		    }
		}
		
		if((params.seculevel==2) || (params.seculevel==3)){ 
		     if(write(nsk,"SECY",4)<0) {
			 close(nsk);
			 exit(0);	    
		     }
		      
		     if(RSA_security(nsk)==1){
			 write(nsk,"AUTN",4); 
			 close(nsk);
			 exit(0);
		     }
		     else {
			  if(write(nsk,"AUTY",4)<0) {
			      close(nsk);
			      exit(0);	    
			  }
		     }
		}
		else{
		    //there isn't security
		    if(write(nsk,"SECN",4)<0) {
			 close(nsk);
			 exit(0);
		     }
		 }
		
		sprintf(cad,params.ip_gate);
		strcat(cad," ");
		strcat(cad,ip_dest);
		strcat(cad," ");
		strcat(cad,params.ip_mask);
				
		if (send(nsk,cad,50,0)==-1){ 
			 close(nsk);
			 exit(0);			
		}
		
		if (!bnep_accept_connection(nsk, role, netdev)) {
			if(num_clients==0){
			                system("brctl addbr pan0");
				system("brctl stp pan0 off"); //disable Spanning Tree Protocol
				system("brctl setfd pan0 0"); //set forwarding delay to 0 seconds
				sprintf(cad2,"ifconfig pan0 %s", params.ip_gate);
				system(cad2);
				system("ifconfig pan0 up");
				system("ifconfig pan0 netmask 255.255.255.0");
				system("echo ""1"" > /proc/sys/net/ipv4/ip_forward");
				sprintf(cad2,"iptables -t nat -A POSTROUTING -o %s -j MASQUERADE",params.interface);
				system(cad2);
				system("iptables -A FORWARD -i pan0 -j ACCEPT");
				system("iptables -A FORWARD -m state --state ESTABLISHED,RELATED -j ACCEPT");
				system("iptables -A FORWARD  -j DROP");
				
			}
			
			sprintf(cad2,"ifconfig  %s 0.0.0.0",netdev);
			system(cad2);
			sprintf(cad2,"brctl addif pan0 %s",netdev);
			system(cad2);		
		} 
	
		close(nsk);
		exit(0);
	}
	
	return 0;
}



//other routines

void configure_params() {
    
     FILE *arch1,*arch2; 
     char aux[255];
     char s2[5] = " =\n\t";
     char *ptr;
     int i=0;
     
     system("route -e | grep default | awk '{print $8}' >> /tmp/interface.txt");
     if((arch1=fopen("/tmp/interface.txt","r"))==NULL){
	 ptr="eth0";
	 for(i;i<10;i++)
     		params.interface[i]=*(ptr+i);
	i=0;
     }
     else {
	 fscanf(arch1," %s\n",params.interface);
     }
	
     if((arch2=fopen(CONF_FILE,"r"))==NULL){ 
	params.max_hosts=5;
	ptr="10.0.0.1";
	for(i;i<15;i++)
     		params.ip_gate[i]=*(ptr+i);
	i=0;
	ptr="255.255.255.0";
	for(i;i<15;i++)
     		params.ip_mask[i]=*(ptr+i);
	i=0;
	params.seculevel=0; 
     }
     else {
	
	fscanf(arch2," %s\n",aux);
   	ptr = strtok( aux, s2 );    
   	ptr = strtok( NULL, s2 );  
	params.max_hosts=atoi(ptr);

	fscanf(arch2," %s\n",aux);
   	ptr = strtok( aux, s2 );    
   	ptr = strtok( NULL, s2 );   
	for(i;i<15;i++)
     		params.ip_gate[i]=*(ptr+i);
	i=0;

	fscanf(arch2," %s\n",aux);
   	ptr = strtok( aux, s2 );   
   	ptr = strtok( NULL, s2 );    
	for(i;i<15;i++)
     		params.ip_mask[i]=*(ptr+i);
	i=0;
	
	fscanf(arch2," %s\n",aux);
   	ptr = strtok( aux, s2 );    
   	ptr = strtok( NULL, s2 );    
     	params.seculevel=atoi(ptr);
	
	fclose(arch2);                        
     }    

     suma_ip(0);
      if((params.seculevel==2)|| (params.seculevel==3)){
	 RSA_write_files();
     }
  
 } 
 

char * suma_ip (int i) {
     
     struct sockaddr_in sum; 
      
     sum.sin_addr.s_addr = inet_addr("0.0.0.1"); 
     if(i==0) dest.sin_addr.s_addr = inet_addr(params.ip_gate); 
     dest.sin_addr.s_addr=dest.sin_addr.s_addr+sum.sin_addr.s_addr;
     set_last_ip(inet_ntoa(dest.sin_addr));
   
     return inet_ntoa(dest.sin_addr);
}


int get_last_ip(){
    FILE *arch;
    char last_ip[15];
    
    if((arch=fopen(IP_LAST,"r"))==NULL) return 1;
    fscanf(arch,"%s\n",last_ip);
    inet_aton(last_ip,&(dest.sin_addr));
    fclose(arch);
    
    return 0;
}

void set_last_ip (char* ip){
    
    FILE *arch;
    arch=fopen(IP_LAST,"w");
    fprintf(arch,"\n%s",ip);
    fclose(arch);
}

int any_client_served() {
    
     FILE *arch;
    char last_ip[15];
    struct sockaddr_in sum, ip;   
  
    sum.sin_addr.s_addr = inet_addr("0.0.0.1"); 
    
    if((arch=fopen(IP_LAST,"r"))==NULL) return 2;
    fscanf(arch,"%s\n",last_ip);
    fclose(arch);

    ip.sin_addr.s_addr = inet_addr(last_ip); 
    ip.sin_addr.s_addr=ip.sin_addr.s_addr-sum.sin_addr.s_addr;

    if ((strncmp(inet_ntoa(ip.sin_addr), params.ip_gate,strlen(params.ip_gate)))==0){
	return 0;
    }
    else{
	return 1;   
    }
    
}
