/*
*  C Implementation: Gateway_Server
*
* Copyright (C) -2007  MªCruz Olivas Delgado <maoldel@teleco.upv.es>
*
* 	This file is part of MANET_Gateway.

    MANET_Gateway is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MANET_Gateway is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MANET_Gateway; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
* 
*
*/

#include "listsc.h"

int auto_insert(List *list, char *device, char *string_address){
    
    Nodetype  *previous, *newnode;
    int aux;
    
    /* Create a new node */
    newnode = (Nodetype *)malloc(sizeof(Nodetype));
    /* If the list is empty */
    if(EmptyList(*list)) {
	newnode->next= *list; 
	newnode->id=1;
	newnode->device = device;
	newnode->string_addr = string_address;
	*list = newnode;
    }
    else {	
	previous = *list;
	while(previous->next) 
		previous = previous->next;
	aux =(previous->id);
	newnode->id=aux+1; 
	newnode->device = device;
	newnode->string_addr = string_address;
	newnode->next= previous->next;
	previous->next = newnode;
	}

    return newnode->id;
}



void Erase(List *list, int v){
    
    Nodetype *previous, *node;
    node = *list;
    previous = NULL;
    
    while(node && node->id < v) {
	previous = node; 
	node = node->next;
    }
    if(!node || node->id != v) return;
    else { 
	if(!previous) 
		*list = node->next;
	else 
		previous->next = node->next;
	free(node);
    }

}

int EmptyList(List list){
    
    return (list == NULL);
}

void EraseList(List *list){
    Nodetype *node;

    while(*list) {
	node = *list;
	*list = node->next;
	free(node);
    }
}

void ShowList(List list){
    Nodetype *node;
    node = list;

    if(!EmptyList(list)){
	while(node) {
		node = node->next;
	}
    }
}

Nodetype *ListNode(List list, int id){
    
    Nodetype *node;
    node = list;

    while(node) {
	if((node->id)== id) return node;
	node = node->next;
    }
    return NULL;
}



