#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <qmainwindow.h>
#include <qapplication.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qpixmap.h>
#include <qlistbox.h>
#include <qpushbutton.h>
#include <qevent.h>
#include <qmessagebox.h>
#include <signal.h>
#include <qbuttongroup.h>
#include <qaction.h>
#include <qmenubar.h>
#include "thread.h"
#include "parameterdialog.h"
#include "gatewayserver.h"

class QAction;
class QLabel;
class QPixmap;
class QFrame;
class QPushButton;
class QListBox;
class QHBoxLayout;
class QVBoxLayout;
class Thread;
class ParameterDialog;


class MainWindow : public QMainWindow
{
    Q_OBJECT
    //friend class Thread;
public:
    MainWindow(QWidget *parent = 0, const char *name = 0);
    void closeEvent( QCloseEvent* ce );
    void customEvent(QCustomEvent *event);
     
private:
    int init();	    
    int descr_local_device();
    void createMenuBar();
    
private slots:
    void parameters();
    void startorstopServer();
    void showconnections();
    void delconnection();
    void delallconnections();
    void about();
    
private:
    int clients;
    int max_clients;
    ifaces_t iface;
    bool begin;
    List list;
    
    QLabel *grclogoLabel;
    QLabel *bluetoothlogoLabel;
    QLabel *clientsnumberLabel;
    QLabel *clientsvalueLabel;
    QLabel *maxclientsLabel;
    QLabel *barLabel;
    QLabel *addressvalue;
    QLabel *namevalue;
    QLabel *typevalue;

    QButtonGroup *localdeviceButtonGroup;

    QPushButton *startorstopButton;    
    QPushButton *parametersButton;
    QPushButton *exitButton;
    QPushButton *delallButton;
    QPushButton *delconButton;

    QListBox *editorText;

    QHBoxLayout *topLayout;
    QVBoxLayout *topLayoutleft;
        
    QHBoxLayout *mediumLayout;
    QVBoxLayout *mediumLayoutleft;
      
    QHBoxLayout *bottomLayout;
    QVBoxLayout *bottomLayoutrigth;
    QHBoxLayout *bottomLayoutnum;
    
    QVBoxLayout *mainLayout;

    QPopupMenu *helpMenu;
    QMenuBar *menuBar;
    
    QAction *aboutAct;
    QAction *aboutQtAct;
    
    Thread listenThread;
    Thread2 countThread;

    ParameterDialog *parameterDialog;
    
};

#endif
 
