#ifndef PARAMETERDIALOG_H
#define PARAMETERDIALOG_H

#include <qmessagebox.h>
#include <qdialog.h>
#include "gatewayserver.h"


class QLabel;
class QLineEdit;
class QPushButton;
class QHBoxLayout;
class QVBoxLayout;
class QComboBox;


class ParameterDialog : public QDialog
{
    Q_OBJECT
public:
    ParameterDialog(QWidget *parent=0, const char *name=0);
    
private slots:
    void submit();
    void activatepin(int);
private:
    
    QLabel *securityLabel;
    QLabel *pinLabel;
    QLabel *ipgateLabel;
    QLabel *ipmaskLabel;
    QLabel *maxhostsLabel;
    QLabel *rtprotocolLabel;
    
    QComboBox *securityComboBox;
    QLineEdit *pinLineEdit;
    QLineEdit *ipgateLineEdit;
    QLineEdit *ipmaskLineEdit;
    QComboBox *maxhostsComboBox;
    QComboBox *rtprotocolComboBox;

    QHBoxLayout *securityLayout;
    QHBoxLayout *pinLayout;
    QHBoxLayout *ipgateLayout;
    QHBoxLayout *ipmaskLayout;
    QHBoxLayout *maxhostsLayout;
    QHBoxLayout *rtprotocolLayout;
    QHBoxLayout *buttonLayout;
    QVBoxLayout *mainLayout;
    QPushButton *okButton;
    QPushButton *cancelButton;
    
};
#endif
 
