/*
  *  C Implementation: Gateway_Server
  *
  * Copyright (C) -2007  MªCruz Olivas Delgado <maoldel@teleco.upv.es>
  *
  *	This file is part of MANET_Gateway.

    MANET_Gateway is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    MANET_Gateway is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with MANET_Gateway; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
  *
    
  */

#include "thread.h"



TransactionStartEvent::TransactionStartEvent() : QCustomEvent(TransactionStart){

}



Thread::Thread(){
    
    stopped=false;
    targetWidget=NULL;
}

void Thread::setTargetWidget(QWidget *widget){
    
    targetWidget = widget;
}


void Thread::run(){
    
   stopped=false;
   int count=0;
   int i;
   
   pid=fork();
   if(!pid){
       do_listen();
   }
  while(!stopped){
	   i= bnep_count_connections();
	   if(i!=count){
	       TransactionStartEvent *event = new TransactionStartEvent();
	        QApplication::postEvent(targetWidget, event);
	        count=i;
	        if((i==0)&&(any_client_served()==1)){
		   system("ifconfig pan0 down");
		   system("brctl delbr pan0");
	       }
	   }
	   msleep(250);
   }

    
}

void Thread::stop(){
    
     stopped = true;
     get_last_ip();
     kill(pid,SIGKILL);
    
}

Thread2::Thread2(){
    
    stopped=false;
    targetWidget=NULL;
}

void Thread2::setTargetWidget(QWidget *widget){
    
    targetWidget = widget;
}


void Thread2::run(){
    
   stopped=false;
   int i;
   int count=0;
   
   while(!stopped){
       if((i= bnep_count_connections()==0)){
	     TransactionStartEvent *event = new TransactionStartEvent();
	    QApplication::postEvent(targetWidget, event);
	    stopped=true;
       }else if(i!=count){
	      TransactionStartEvent *event = new TransactionStartEvent();
	      QApplication::postEvent(targetWidget, event);
	      count=i;
	   }
      }
      msleep(250);
}

void Thread2::stop(){
    
    stopped = true;
}

